from inspect import isfunction


class Tag(object):
    """Class that abstract tags."""
    def __init__(self, name, valuable, ttl):
        """
        :param string name: tag name
        :param valuable: something that gives tag value, string or function
        :param None,int ttl: Time to live for caching the tags
        """
        self.name = name
        self._value = valuable
        self.ttl = ttl

    @property
    def value(self):
        """Returns tag value."""
        if isfunction(self._value):
            return self._value()

        return self._value
